//____Prueba PENETRATOR_2023_
//SDL/C
//SETA43

#include <stdio.h>

#include <stdlib.h>

#include <time.h>
#include "define.h"

#ifdef SDL2
    #include "SDL2/SDL.h"
    #include "SDL2/SDL_ttf.h"
    #include "SDL2/SDL_image.h"
    #include "SDL2/SDL_mixer.h"
#else
    #include <SDL/SDL.h>
    #include "SDL/SDL_ttf.h"
    #include "SDL/SDL_image.h"
    #include "SDL/SDL_mixer.h"
#endif

#include "main.h"
#include "agrafi.h"

#include "modeG.h"


char titulo[]=" Penetrator \n";

int inkeyM(void);
int waitQuit(void);
void printc(int x, int y, char* temp);
void printn(int x, int y, long temp);
void impri(int x, int y, char c);
char *inputc(int x, int y);
void imprixxx(int xi, int yi, int xo, int yo, int w, int h);

void Inicializar(void);
void animarOK(void);
void animarMuerte(void);
void animarInicio(void);

void Repaint(void);
void printPanta(void);

int load_mapa(void);
int checkNaveEnemigo(int x, int y);
int checkEnemigo(int x,int y);

void printDisparos(void);
void disparoGo(void);

void printBombas(void);
void bombasGo(void);
void incXbombas(int d);

void printEnemigos(void);
void incXenemigos(int d);
void sumaEnemigo(int x,int y,int s);

int getNave(int x, int y,unsigned int color );

void resetMapa(void);
inline int checkAreas(int x,int y,int w,int h,int xe,int ye,int we,int he);

inline void refrescoFAST(void)
{ 
#ifdef SDL2
    SDL_UpdateWindowSurface(window);
#else
    SDL_Flip(screen);
#endif
}

unsigned int tiempoX,tiempoX2;
#define RETARDO 50

int Puntos,Energia;
int desplaza;
int naveX,naveY,ix,iy;
int nivel;

char mapa[16384];
char mapaOriginal[16384];

Mix_Chunk *aexplota = NULL;
Mix_Chunk *adisparo = NULL;
Mix_Chunk *abeep = NULL;
Mix_Chunk *aover = NULL;
Mix_Chunk *aplau = NULL;
Mix_Chunk *ainit = NULL;
Mix_Chunk *abomba = NULL;


#define DESPLA_MAX 2250
#define DESPLA_I 2
#define DESPLA_ESCENARIO 3


#define RADAR  0,16
#define RADAR_I  0,32
#define RADAR_D  16,32
#define NAVE1	16,16
#define CARA  32,16
#define NAVE0	48,16
#define NAVE0_C 48,0

#define DISPARO1  96,16
#define BOMBA1 80,0
#define EXPLO1 32,32
#define EXPLO2 48,32

#define GAME_OVER 128,16
#define PENETRATOR 128,0

#define BOMBAS_VELO 3
#define NUM_BOMBAS  4
#define DISPARO_VELO 8
#define NUM_DISPAROS  5
#define NUM_ENEMIGOS  20

struct ENEMIGOS {
    int x;
    int y;
    int s;
    int velo;
};
struct ENEMIGOS enemigo[NUM_ENEMIGOS];

struct BOMBAS {
    int x;
    int y;
    int s;
    int velo;
};
struct BOMBAS bombas[NUM_BOMBAS];

struct DISPA {
    int x;
    int y;
    bool s;
    int velo;
};
struct DISPA disparo[NUM_DISPAROS];
//====================JUEGO=======================
int mouse_x,mouse_y;

#include "puntos.h"

int main (int argc, char *argv[])
{
 //   int z;
    int quit = 0;
    int SimbolKey;
    bool fullScreen = false;

    if (init(320,240) == 0 ) return 1;
    //Fondo,graficos,fuentes
    if (load_files(NULL, (char*)"anave.png", (char*)"setam.ttf") == 0 ) return 2;
    if(Mix_OpenAudio(22050, MIX_DEFAULT_FORMAT, MIX_DEFAULT_CHANNELS, 1024) == -1) //Initialisation de l'API Mixer
        {  printf("%s", Mix_GetError()); }
    else
        {  printf("OK MIX\n");  }
        
    Mix_Music *musique; 
    musique = Mix_LoadMUS("apene.ogg");  

    indexG(0,32,8,8);
    screenFull(fullScreen);
    SDL_ShowCursor(SDL_DISABLE);
    
    load_mapa();
    
    aexplota = Mix_LoadWAV( "aexplota.wav" );
    adisparo= Mix_LoadWAV( "adisparo.wav" );
    abeep = Mix_LoadWAV( "abeep.wav" );
    aover= Mix_LoadWAV( "aover.wav" );
    aplau = Mix_LoadWAV( "aplau.wav" );
    ainit = Mix_LoadWAV( "ainit.wav" );
    abomba = Mix_LoadWAV( "abomba.wav" );
    
    load_puntos();
    puntuar(0);
Inicio:
    Inicializar();
    animarInicio();
    Mix_PlayMusic(musique, -1);
    
    tiempoX=SDL_GetTicks()+RETARDO;
    //__________JUEGO___________________________
    while (quit==0)
    {
        SDL_Delay(10);

        while ( SDL_PollEvent( &event ) )
        {
            mouse_x=event.button.x;
			mouse_y=event.button.y;
            
            switch (event.type)
            {
            case  SDL_KEYUP:
                SimbolKey = event.key.keysym.sym;
                switch (SimbolKey)
                    {
                        case SDLK_UP :
                            iy=0;
                            break;
                        case SDLK_DOWN :
                            iy=0;
                            break;
                        case SDLK_LEFT :
                            ix=0;
                            break;
                        case SDLK_RIGHT :
                            ix=0;
                            break;
                    }
                break;
            case  SDL_KEYDOWN:
                SimbolKey = event.key.keysym.sym;
                switch (SimbolKey)
                {
                case  SDLK_F1:
                    fullScreen = !fullScreen;
                    screenFull(fullScreen);
                    Repaint();
                    break;
                case  SDLK_F4:
                    Inicializar();
                    Repaint();
                    break;
                case  SDLK_ESCAPE:
                    quit = 1;
                    break;
                case SDLK_UP :
                    iy=-DESPLA_I;
                    break;
                case SDLK_DOWN :
                    iy=DESPLA_I;
                    break;
                case SDLK_LEFT :
                    ix=-DESPLA_I;
                    break;
                case SDLK_RIGHT :
                    ix=DESPLA_I;
                    break;
                case SDLK_s :

                    break;
                case SDLK_d :
                    disparoGo();
                    break;
                case SDLK_SPACE :
                    bombasGo();
                    break;
#ifdef TEST                
                case SDLK_1 :
                    desplaza=70;
                    naveX=10; naveY=10;
                    nivel=1;
                    resetMapa();
                    break;    
                case SDLK_2 :
                    desplaza=560;
                    naveX=70; naveY=80;
                    nivel=2;
                    resetMapa();
                    break;
                case SDLK_3 :
                    desplaza=940;
                    naveX=80; naveY=70;
                    nivel=2;
                    resetMapa();
                    break;
                case SDLK_4 :
                    desplaza=1560;
                    naveX=40; naveY=132;
                    nivel=4;
                    resetMapa();
                    break;
                case SDLK_5 :
                    desplaza=2070;
                    naveX=40; naveY=90;
                    nivel=5;
                    resetMapa();
                    break; 
#endif
                }

                break;
            case  SDL_QUIT:
                quit = 1;
                break;
            }
        }

        if(SDL_GetTicks()>tiempoX)
        {
            tiempoX=SDL_GetTicks()+RETARDO;
            
            naveY+=iy;
            naveX+=ix;
            if(naveY<0)naveY=0;
            if(naveY>170) naveY=170;
            if(naveX<0)naveX=0;
            if(naveX>300)naveX=300;
            
            if(tiempoX2>1)
                {
                  tiempoX2=0;
                  if(desplaza<DESPLA_MAX)
                    { 
                        desplaza++;
                        incXenemigos(DESPLA_ESCENARIO);
                        incXbombas(DESPLA_ESCENARIO);
                    }
                }
            tiempoX2++;
            printPanta();
            if(Energia<1 || nivel>5) 
                {
                    Mix_PauseMusic();
                    animarMuerte();
                    puntuar(Puntos);
                    if(1==waitQuit()) goto FinPrograma;  //Salir
                    goto Inicio;
                }
            
        }
    }

FinPrograma:
    //Cerrar todo el SDL
    Mix_FreeMusic(musique);
    clean_up();
    printf("Fin_%s\n",titulo);
    SDL_Delay(400);
    return 0;
}


//____________________FIN____________


void Repaint(void)
{
    printPanta();
}

void printPanta(void)
{
 static char temp[50];
 int x,i,z,ff;
 unsigned char sup,inf,nav,supU,infU;
 
    switch (nivel)
        {
            case 1:
                cls(0,0,0);
            break;
            case 2:
                cls(0,100,0);
            break;
            case 3:
                cls(0,0,100);
            break;
            case 4:
                cls(100,0,0);
            break;
            default:
                cls(255,0,0);
            break;
            
        }

    setcolor(255,255,255);

    i=desplaza*DESPLA_ESCENARIO;
    for(x=0;x<106;x++,i+=3)
    {
		 nav=mapa[i];
		 inf=mapa[i+1];
		 sup=mapa[i+2];
		 
		 z=x+x+x;
		 plot(z,inf);
		 if(sup>8) plot(z,sup);
		 plot(z+1,inf);
		 if(sup>8) plot(z+1,sup);
		 plot(z+2,inf);
		 if(sup>8) plot(z+2,sup);
		 if(x!=0)
		 {
			if(infU!=inf) line(z,inf,z,infU);
			if(supU!=sup) line(z,sup,z,supU);
		 }
		 infU=inf;
		 supU=sup;
		 if(nav!=0) 
			{
				sumaEnemigo(z,inf,nav);
				if(nav>10)nivel++;
				mapa[i]=0;
			}
    }
        
    printEnemigos();
    printDisparos();
    printBombas(); 
    
    if(1==checkNaveEnemigo(naveX,naveY))
        { 
            imprixxx(NAVE0_C,naveX,naveY,20,16);
            Mix_PlayChannel( -1, aexplota, 0 );
            Energia--;
        }
	
	//Chequea nave con cueva
    if(0==getNave(naveX,naveY,0xffffff00))
        {
            imprixxx(NAVE0,naveX,naveY,20,16);
        }
     else
        { 
            imprixxx(NAVE0_C,naveX,naveY,20,16);
            Mix_PlayChannel( -1, aexplota, 0 );
            Mix_PlayChannel( -1, abeep, 0 );
            Energia--;
        }
    
     if(nivel>4 && desplaza>2100)
        {
          ff=0; 
          for(z=0; z<NUM_ENEMIGOS; z++)
           {
            if(enemigo[z].s==1)   ff++;   
           }
          if(ff==0 ) animarOK();
        }
     
     sprintf(temp, "     FASE=%d  ENERGIA=%d  PUNTOS=%d",nivel,Energia,Puntos);
	 printcG(0,220,temp);
     refrescoFAST(); 
}


void Inicializar(void)
{
    resetMapa();
    Energia=30;
    Puntos=0;
    
    desplaza=0;
    naveX=10; naveY=10;
    nivel=0;
}



void animarMuerte(void)
{
  printf("GAME OVER\n");
  imprixxx(GAME_OVER,100,100,110,16);
  refrescoFAST();
  Mix_PlayChannel( -1, aover, 0 );
  SDL_Delay(2000);
  Mix_PlayChannel( -1, aover, 0 );
  SDL_Delay(2000);
  Mix_PlayChannel( -1, aover, 0 );
  SDL_Delay(2000);

  setcolor(255,0,0);
    
    for(int z=0;z<120;z++)
        {
         line(0,z,319,z);
         line(0,239-z,319,239-z);
         imprixxx(NAVE0_C,naveX,naveY,20,16);
         refrescoFAST();
         SDL_Delay(10);
        }
    SDL_Delay(2000);   
}


void animarInicio(void)
{
  
 int x=0,dire=5,vari=10;
    Mix_PlayChannel( -1, ainit, 0 );
 rebote:
    cls(0,0,0);
    imprixxx(PENETRATOR,100,x,110,16); 
    if(x>220 )goto salto1;
//    printf("%d  %d  \n",x, dire);
    refrescoFAST();
    SDL_Delay(10);
    x+=dire;
    if(dire<0)
        {
          if (x<vari){ dire*=-1;  vari+=vari;}
          goto rebote;
        }
        else
        {
          if (x>100) { dire*=-1; dire+=1;}
          goto rebote;
        }
salto1:
    SDL_Delay(2000);
}

void animarOK(void)
{
    printf("Juego Finalizado\n");
    Mix_PlayChannel( -1, aplau, 0 );
    SDL_Delay(3000);

    setcolor(255,255,255);
    
    for(int z=0;z<120;z++)
        {
         line(1,z,319,z);
         line(1,239-z,319,239-z);
         imprixxx(NAVE0_C,naveX,naveY,20,16);
         refrescoFAST();
         SDL_Delay(10);
        }
    SDL_Delay(2000);   
    desplaza=70;
    naveX=10; naveY=10;
    nivel=1;
    resetMapa();
    Energia+=15;
}

int load_mapa(void)
{
 FILE *pf;
    if ((pf = fopen("mapa.bin", "rb")) == NULL)
    {
        printf("ERROR en mapa.bin/n");
        return (2);
    }
    else
    {
        int tama=fread(mapaOriginal, 1, 16384, pf);
        printf("TAMA_MAPA=%d\n",tama);
        fclose(pf);
    }
    
    for(int z=0;z<16384;z++) mapa[z]=mapaOriginal[z];
    return(0);
}



int getNave(int x, int y,unsigned int color )
{
  if(1==getline(x,y+4,x+9,y+4,color)) return(1);
  if(1==getline(x+3,y+11,x+19,y+11,color)) return(1);
  if(1==getline(x+2,y+15,x+10,y+15,color)) return(1);
  if(1==getline(x+8,y+4,x+8,y+15,color)) return(1);
  return(0); 
}


//_____Naves____________


void printEnemigos(void)
{
    for(int z=0;z<NUM_ENEMIGOS;z++)
        {
            if(enemigo[z].y<8) { enemigo[z].velo=0; enemigo[z].s=0;}
            
             switch (enemigo[z].s)
                {
                 case 0:
                 //NADA
                 break;
                 case 1:
					if(naveX+32>enemigo[z].x  && naveX-32<enemigo[z].x)
					{
						imprixxx(RADAR,enemigo[z].x,enemigo[z].y-16,16,16);
					}
					else
					{
					 if(naveX-32<enemigo[z].x)
						imprixxx(RADAR_I,enemigo[z].x,enemigo[z].y-16,16,16);
						else
						imprixxx(RADAR_D,enemigo[z].x,enemigo[z].y-16,16,16);
					}
                  
                 break;
                 case 2:
                    imprixxx(NAVE1,enemigo[z].x,enemigo[z].y-16,16,16);
                    if(enemigo[z].velo>0) enemigo[z].y-=enemigo[z].velo;
                    if(enemigo[z].velo==0 && enemigo[z].x>naveX && enemigo[z].x<naveX+50 )enemigo[z].velo=rand() % 4;
                 break;
                 case 9:
                    imprixxx(EXPLO1,enemigo[z].x,enemigo[z].y-16,16,16);
                    enemigo[z].s=10;
                 break;
                 case 10:
                    imprixxx(EXPLO2,enemigo[z].x,enemigo[z].y-16,16,16);
                    enemigo[z].s=0;
                 break;
                 default:
                    //imprixxx(CARA,enemigo[z].x,enemigo[z].y-16,16,16);
                 break;
                 
                }
        }
}


void incXenemigos(int d)
{
    for(int z=0;z<NUM_ENEMIGOS;z++)
        {
            if(enemigo[z].s!=0)
            {
              enemigo[z].x-=d; 
              if(enemigo[z].x<0) enemigo[z].s=0;
            }
        }
}

void sumaEnemigo(int x,int y,int s)
{
   for(int z=0;z<NUM_ENEMIGOS;z++)
        {
            if(enemigo[z].s==0)
            {
              enemigo[z].x=x; 
              enemigo[z].y=y;
              enemigo[z].s=s;
              enemigo[z].velo=rand() % 2;
              break;
            }
        } 
}


int checkEnemigo(int x,int y)
{
    for(int z=0;z<NUM_ENEMIGOS;z++)
        {
            if(enemigo[z].s!=0)
            {
                if(x>enemigo[z].x-8 && x<enemigo[z].x+16 && y>enemigo[z].y-16 && y<enemigo[z].y+16)
                    {
                      switch (enemigo[z].s)
                      {
                       case 1:
                        Puntos+=10;
                        break;
                       case 2:
                        Puntos+=20;
                        break;
                      }
                      enemigo[z].s=9;
					  Mix_PlayChannel( -1, aexplota, 0 );
					  return(1); 
                    }
            }
        }
    return(0);
}



//---Bombas----------------------------------
void printBombas(void)
{
    for(int z=0; z<NUM_BOMBAS; z++)
    {
       switch (bombas[z].s)
        {
            case 0:
            //NADA
            break;

            case 1:
                bombas[z].y+=bombas[z].velo;
                if(bombas[z].y>180) {     bombas[z].s=0;  goto saltoBombas;   }
                if(1==checkEnemigo(bombas[z].x+2,bombas[z].y+5)) 
                     {   bombas[z].s=9;  goto saltoBombas;     }
                if(1==getline(bombas[z].x,bombas[z].y,bombas[z].x,bombas[z].y+6,0xffffff00) )
                        { bombas[z].s=9;   goto saltoBombas;     }
                    else
                        {  imprixxx(BOMBA1,bombas[z].x,bombas[z].y,5,6);  }
            break;
            
            case 9:
                imprixxx(EXPLO1,bombas[z].x,bombas[z].y,16,16);
                bombas[z].s=10;
            break;
        case 10:
                imprixxx(EXPLO2,bombas[z].x,bombas[z].y,16,16);
                bombas[z].s=0;
            break;
        }

saltoBombas:
;
    }

}

void bombasGo(void)
{
    Mix_PlayChannel( -1, abomba, 0 );
    for(int dis=0; dis<NUM_BOMBAS; dis++)
    {
        if(bombas[dis].s==0)
        {
            bombas[dis].x=naveX+10;
            bombas[dis].y=naveY+16;
            bombas[dis].s=1;
            bombas[dis].velo=BOMBAS_VELO;
            break;
        }
    }
}

void incXbombas(int d)
{
    for(int z=0;z<NUM_BOMBAS;z++)
        {
            if(bombas[z].s!=0)
            {
              bombas[z].x-=d; 
              if(bombas[z].x<0) bombas[z].s=0;
            }
        }
}


//----Disparos-------------------------------------
void printDisparos(void)
{
    for(int z=0; z<NUM_DISPAROS; z++)
    {
        if(disparo[z].s==1)
        {
            disparo[z].x+=disparo[z].velo;
            if(disparo[z].x>400) { disparo[z].s=0; break;}
            if(1==checkEnemigo(disparo[z].x,disparo[z].y) ) { disparo[z].s=9; break;}
            if(1==getline(disparo[z].x,disparo[z].y,disparo[z].x+8,disparo[z].y,0xffffff00) )
              {
                disparo[z].s=0; break;
              }
              else
              {  imprixxx(DISPARO1,disparo[z].x,disparo[z].y,20,2); }
        }
    }

}

void disparoGo(void)
{
    Mix_PlayChannel( -1, adisparo, 0 );
    for(int dis=0; dis<NUM_DISPAROS; dis++)
    {
        if(disparo[dis].s==0)
        {
            disparo[dis].x=naveX+32;
            disparo[dis].y=naveY+12;
            disparo[dis].s=1;
            disparo[dis].velo=DISPARO_VELO;
            break;
        }
    }
}


void resetMapa(void)
{
 int z;
  for(z=0;z<16384;z++) mapa[z]=mapaOriginal[z];  
  for(z=0;z<NUM_ENEMIGOS;z++) enemigo[z].s=0;
}


int checkNaveEnemigo(int x, int y)
{
   for(int z=0;z<NUM_ENEMIGOS;z++)
        {			
			switch (enemigo[z].s)
                      {
						
					   case 0:
                       break;
                       case 1:
						if(1==checkAreas(x+2,y+4,18,11, enemigo[z].x,enemigo[z].y-16,15,15))
							{      
							 Puntos+=10;
							 enemigo[z].s=0;
							 Mix_PlayChannel( -1, abeep, 0 );
							 return(1);
							}
                        break;
                       case 2:
							if(1==checkAreas(x+2,y+4,18,11, enemigo[z].x,enemigo[z].y-16,8,15))
								{      
								 Puntos+=20;
								 enemigo[z].s=0;
								 Mix_PlayChannel( -1, abeep, 0 );
								 return(1);
								}
						 //Chequea misiles chocan con techo cueva							
							if( 1==getline(enemigo[z].x+1,enemigo[z].y-16,enemigo[z].x+1,enemigo[z].y-1,0xffffff00))
								{
								  enemigo[z].s=9;
								} 
                        break;
                        default:
                        
                        break;
                      }
        }
    return(0);  
}

inline int checkAreas(int x,int y,int w,int h,int xe,int ye,int we,int he)
{
    if(x-we<xe && x+w>xe && y-he<ye && y+h>ye )   return(1); 
 return(0);
}

//___________Rutinas basicas___________________
int inkeyM()
{
    int tecla;
    SDL_Delay(100);
    while ( SDL_PollEvent( &event ) )
    {
        switch (event.type)
        {
        case  SDL_KEYUP:
            tecla = event.key.keysym.sym;
            if (tecla > 96 && tecla < 123) tecla -= 32;
            return (tecla);
            break;
        case  SDL_QUIT:
            return (27);
            break;
        }
    }
    return (0);
}


int waitQuit(void)
{
    int SimbolKey;
    while(0!=inkeyM()) {}
    while(1)
    {
        SimbolKey=inkeyM();
        if(SimbolKey==27) return(1);
        if(SimbolKey!=0) return(0);
    }
}
//__________________________________
void imprixxx(int xi, int yi, int xo, int yo, int w, int h)
{
    static SDL_Rect clip[ 1 ];
    clip[ 0 ].x = xi;
    clip[ 0 ].y = yi;
    clip[ 0 ].w = w;
    clip[ 0 ].h = h;
    apply_surfaceB( xo, yo, dots, screen, &clip[ 0 ] );
}

void printc(int x, int y, char* temp)
{
    static SDL_Surface *message;
    message = TTF_RenderText_Solid( font, temp, ColorDefault );
    apply_surface( x, y, message, screen );
    SDL_FreeSurface(message);
}

void printn(int x, int y, long temp)
{
    char VARI[20];
    sprintf(VARI, "%d", (int)temp);
    printc(x, y, VARI);
}

void impri(int x, int y, char c)
{
    char VARI[20];
    sprintf(VARI, "%c", c);
    printc(x, y, VARI);
}



/* -------------------------- LEE CADENA DEL TECLADO ----*/

char *inputc(int x, int y)
{

    int zz, n;
    static char VARI[20];

    setcolor(0, 100, 0);
    bar(x, y, x + 100, y + 20);
    setcolor(255, 255, 255);
    refresco();
    for(zz=0; zz<10; zz++) inkeyM();

    n = 0;
    zz = 0;
    while (zz != 10)
    {
        zz = inkeyM();
        if (zz == 13 || zz == 27) goto fin;
        if (zz != 0)
        {
            setcolor(0, 100, 0);
            bar(x, y, x + 100, y + 20);
            setcolor(255, 255, 255);
            if (zz == 8)
            {
                n--;
                if (n < 0)n = 0;
                VARI[n] = 0;
            }
            else
            {
                VARI[n] = zz;
                VARI[n + 1] = 0;
                if (n < 6)n++;
            }
            printc(x, y, VARI);
            //        printf("%s\n",VARI);
            refresco();
        }
    }
fin:
    VARI[n] = 0;
    return (VARI);
}

